﻿Imports System.Xml

Public Class frmEditor

    Public radek As New List(Of lineObject)
    Public takt As Integer = 5                      '3 = 3/4, 4 = 4/4, 5 = 5/4
    Dim currentFile As String = ""
    Private cursorPos As Integer = 0

    ''' <summary>
    ''' Vykreslení notového řádku
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub PictureBox1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PictureBox1.Paint
        HScrollBar1.Maximum = Math.Max(radek.Count - 1, 0)

        With e.Graphics
            .Clear(Color.White)
            .SmoothingMode = Drawing2D.SmoothingMode.HighQuality

            Dim x As Integer = 0
            Dim doba As Single = 0

            If HScrollBar1.Value < 1 Then
                'vykreslit notový klíč
                .DrawImage(My.Resources.klic, x + 5, 24, 31, 84)
                x += 40
            End If

            If HScrollBar1.Value < 2 Then
                'vykreslit takt
                Select Case takt
                    Case 3 : .DrawImage(My.Resources.takt_3, x, 50, 16, 40)
                    Case 4 : .DrawImage(My.Resources.takt_4, x, 50, 16, 40)
                    Case 5 : .DrawImage(My.Resources.takt_5, x, 50, 16, 40)
                End Select
                x += 35
            End If

            'spočítat doby nevykreslovaných not 
            For i As Integer = 0 To HScrollBar1.Value - 1
                doba += radek(i).delka
            Next
            While doba > takt
                doba -= takt
            End While
            'vykreslit noty a pomlky
            For i As Integer = HScrollBar1.Value To radek.Count - 1
                Dim o As lineObject = radek(i)
                Dim d As Single = o.delka
                Dim start As Integer = x

                If o.GetType Is GetType(Nota) Then      'nota
                    Dim pocet As Integer = 0
                    'rozdělit notu po řádcích
                    While doba + d >= takt
                        x += Nota.Draw(e.Graphics, x, 50, CType(o, Nota).vyska, takt - doba, pocet)
                        d -= (takt - doba)
                        doba = 0 : .DrawLine(Pens.Black, x + 5, 50, x + 5, 90) : x += 30
                    End While
                    If d > 0 Then
                        'vykreslit poslední notu
                        x += Nota.Draw(e.Graphics, x, 50, CType(o, Nota).vyska, d, pocet)
                        doba += d
                    End If
                    'oblouček
                    If pocet > 1 Then
                        If CType(o, Nota).vyska > VyskaTonu.h Then
                            .DrawArc(Pens.Black, start, 10, x - start - 20, 40, 180, 180)
                        Else
                            .DrawArc(Pens.Black, start, 90, x - start - 20, 40, 180, -180)
                        End If
                    End If

                ElseIf o.GetType Is GetType(Pomlka) Then  'pomlka
                    While doba + d >= takt
                        x += Pomlka.Draw(e.Graphics, x, 50, o.delka)
                        d -= (takt - doba)
                        doba = 0 : .DrawLine(Pens.Black, x + 5, 50, x + 5, 90) : x += 30
                    End While
                    If d > 0 Then
                        x += Pomlka.Draw(e.Graphics, x, 50, o.delka)
                        doba += d
                    End If

                End If

                If i = cursorPos Then .FillRectangle(Brushes.Blue, start, 110, x - start, 5)

                If x > PictureBox1.ClientSize.Width Then Exit For
            Next
            If cursorPos = radek.Count Then .FillRectangle(Brushes.Blue, x, 110, 20, 5)

            'vykreslit osnovu
            For i As Integer = 0 To 4
                .DrawLine(Pens.Black, 0, 50 + i * 10, Me.ClientSize.Width, 50 + i * 10)
            Next
        End With
    End Sub

    ''' <summary>
    ''' Načtení notového souboru
    ''' </summary>
    ''' <param name="filename"></param>
    ''' <remarks></remarks>
    Public Sub OpenFile(ByVal filename As String)
        currentFile = filename
        'otevřít XML soubor
        Dim doc As New XmlDocument
        doc.Load(filename)

        'načíst takt
        Select Case doc.SelectSingleNode("/skladba").Attributes("takt").Value
            Case "3/4" : takt = 3 : miT3.Checked = True
            Case "4/4" : takt = 4 : miT4.Checked = True
            Case "5/4" : takt = 5 : miT5.Checked = True
            Case Else : Throw New Exception("Takt určený v souboru neexistuje.")
        End Select

        'projít elementy
        For Each n As XmlNode In doc.SelectSingleNode("/skladba").ChildNodes
            Select Case n.Name
                Case "nota"
                    Dim d As String = n.Attributes("delka").Value
                    Dim v As String = n.Attributes("vyska").Value
                    radek.Add(New Nota(d, v))

                Case "pomlka"
                    Dim d As String = n.Attributes("delka").Value
                    radek.Add(New Pomlka(d))

                Case Else : Throw New Exception("Notová značka daného typu není podporována!")
            End Select
        Next

        'uvolnit paměť
        doc = Nothing
    End Sub

    Private Sub miT3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miT3.Click
        takt = 3
        miT3.Checked = True : miT4.Checked = False : miT5.Checked = False
        PictureBox1.Invalidate()
    End Sub

    Private Sub miT4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miT4.Click
        takt = 4
        miT3.Checked = False : miT4.Checked = True : miT5.Checked = False
        PictureBox1.Invalidate()
    End Sub

    Private Sub miT5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miT5.Click
        takt = 5
        miT3.Checked = False : miT4.Checked = False : miT5.Checked = True
        PictureBox1.Invalidate()
    End Sub

    Private Sub HScrollBar1_Scroll(ByVal sender As Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles HScrollBar1.Scroll
        PictureBox1.Invalidate()
    End Sub

    Private Sub KeyCatcher_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles KeyCatcher.KeyDown
        Static currentLength As Single = 1

        'ovládání aplikace klávesami
        Select Case e.KeyCode
            Case Keys.C : radek.Insert(cursorPos, New Nota(currentLength, 0 + IIf(e.Shift, 12, 0))) : cursorPos += 1
            Case Keys.D : radek.Insert(cursorPos, New Nota(currentLength, 2 + IIf(e.Shift, 12, 0))) : cursorPos += 1
            Case Keys.E : radek.Insert(cursorPos, New Nota(currentLength, 4 + IIf(e.Shift, 12, 0))) : cursorPos += 1
            Case Keys.F : radek.Insert(cursorPos, New Nota(currentLength, 5 + IIf(e.Shift, 12, 0))) : cursorPos += 1
            Case Keys.G : radek.Insert(cursorPos, New Nota(currentLength, 7 + IIf(e.Shift, 12, 0))) : cursorPos += 1
            Case Keys.A : radek.Insert(cursorPos, New Nota(currentLength, 9 + IIf(e.Shift, 12, 0))) : cursorPos += 1
            Case Keys.H : radek.Insert(cursorPos, New Nota(currentLength, 11 + IIf(e.Shift, 12, 0))) : cursorPos += 1
            Case Keys.Delete : If cursorPos < radek.Count Then radek.RemoveAt(cursorPos)
            Case Keys.Back : If cursorPos > 0 Then radek.RemoveAt(cursorPos - 1) : cursorPos -= 1
            Case Keys.Subtract
                If cursorPos < radek.Count AndAlso radek(cursorPos).delka > 0.5 Then radek(cursorPos).SetDelka(radek(cursorPos).delka - 0.5)
                If cursorPos = radek.Count AndAlso currentLength > 0.5 Then currentLength -= 0.5
            Case Keys.Add
                If cursorPos < radek.Count AndAlso radek(cursorPos).delka < 10 Then radek(cursorPos).SetDelka(radek(cursorPos).delka + 0.5)
                If cursorPos = radek.Count AndAlso currentLength < 10 Then currentLength += 0.5
            Case Keys.Up
                If cursorPos < radek.Count AndAlso radek(cursorPos).GetType Is GetType(Nota) AndAlso CType(radek(cursorPos), Nota).vyska < 23 Then CType(radek(cursorPos), Nota).SetVyska(CType(radek(cursorPos), Nota).vyska + 1)
            Case Keys.Down
                If cursorPos < radek.Count AndAlso radek(cursorPos).GetType Is GetType(Nota) AndAlso CType(radek(cursorPos), Nota).vyska > 0 Then CType(radek(cursorPos), Nota).SetVyska(CType(radek(cursorPos), Nota).vyska - 1)
            Case Keys.Left
                If cursorPos > 0 Then cursorPos -= 1
            Case Keys.Right
                If cursorPos < radek.Count Then cursorPos -= 1
            Case Keys.Home
                cursorPos = 0
            Case Keys.End
                cursorPos = radek.Count
            Case Keys.Space
                radek.Insert(cursorPos, New Pomlka(currentLength))
            Case Keys.NumPad1
                If cursorPos < radek.Count Then radek(cursorPos).SetDelka(4)
                If cursorPos = radek.Count Then currentLength = 4
            Case Keys.NumPad2
                If cursorPos < radek.Count Then radek(cursorPos).SetDelka(2)
                If cursorPos = radek.Count Then currentLength = 2
            Case Keys.NumPad3
                If cursorPos < radek.Count Then radek(cursorPos).SetDelka(1)
                If cursorPos = radek.Count Then currentLength = 1
            Case Keys.NumPad4
                If cursorPos < radek.Count Then radek(cursorPos).SetDelka(0.5)
                If cursorPos = radek.Count Then currentLength = 0.5
        End Select

        HScrollBar1.Maximum = Math.Max(radek.Count - 1, 0)
        HScrollBar1.Value = Math.Max(cursorPos - 3, 0)

        PictureBox1.Invalidate()

    End Sub

    Private Sub UložitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UložitToolStripMenuItem.Click
        'uložit, pokud není vybrán soubor, zeptat se
        If currentFile = "" Then UložitjakoToolStripMenuItem_Click(Nothing, Nothing) Else SaveFile()
    End Sub

    Private Sub UložitjakoToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UložitjakoToolStripMenuItem.Click
        'zeptat se na soubor
        If SaveFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            currentFile = SaveFileDialog1.FileName
            SaveFile()
        End If
    End Sub

    Public Sub SaveFile()
        'uložit soubor
        Dim w As New XmlTextWriter(currentFile, Nothing)
        w.WriteStartDocument()

        w.WriteStartElement("skladba")
        Select Case takt
            Case 3 : w.WriteAttributeString("takt", "3/4")
            Case 4 : w.WriteAttributeString("takt", "4/4")
            Case 5 : w.WriteAttributeString("takt", "5/4")
        End Select

        For i As Integer = 0 To radek.Count - 1
            If radek(i).GetType Is GetType(Nota) Then
                w.WriteStartElement("nota")
                w.WriteAttributeString("delka", radek(i).delka.ToString().Replace(",", "."))
                Dim ton As String = ""
                Select Case CType(radek(i), Nota).vyska
                    Case VyskaTonu.c : ton = "C"
                    Case VyskaTonu.cis : ton = "Cis"
                    Case VyskaTonu.d : ton = "D"
                    Case VyskaTonu.dis : ton = "Dis"
                    Case VyskaTonu.e : ton = "E"
                    Case VyskaTonu.f : ton = "F"
                    Case VyskaTonu.fis : ton = "Fis"
                    Case VyskaTonu.g : ton = "G"
                    Case VyskaTonu.gis : ton = "Gis"
                    Case VyskaTonu.a : ton = "A"
                    Case VyskaTonu.ais : ton = "Ais"
                    Case VyskaTonu.h : ton = "H"
                    Case VyskaTonu.sc : ton = "c"
                    Case VyskaTonu.scis : ton = "cis"
                    Case VyskaTonu.sd : ton = "d"
                    Case VyskaTonu.sdis : ton = "dis"
                    Case VyskaTonu.se : ton = "e"
                    Case VyskaTonu.sf : ton = "f"
                    Case VyskaTonu.sfis : ton = "fis"
                    Case VyskaTonu.sg : ton = "g"
                    Case VyskaTonu.sgis : ton = "gis"
                    Case VyskaTonu.sa : ton = "a"
                    Case VyskaTonu.sais : ton = "ais"
                    Case VyskaTonu.sh : ton = "h"
                End Select
                w.WriteAttributeString("vyska", ton)
                w.WriteEndElement()
            Else
                w.WriteStartElement("pomlka")
                w.WriteAttributeString("delka", radek(i).delka.ToString().Replace(",", "."))
                w.WriteEndElement()
            End If
        Next

        w.WriteEndDocument()
        w.Flush()
        w.Close()
    End Sub

    Private Sub frmEditor_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If MsgBox("Chcete uložit změny v souboru " & Me.Text & "?", MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
            UložitToolStripMenuItem_Click(Nothing, Nothing)
        End If
    End Sub
End Class