﻿Public Enum VyskaTonu
    c = 0
    cis = 1
    d = 2
    dis = 3
    e = 4
    f = 5
    fis = 6
    g = 7
    gis = 8
    a = 9
    ais = 10
    h = 11
    sc = 12
    scis = 13
    sd = 14
    sdis = 15
    se = 16
    sf = 17
    sfis = 18
    sg = 19
    sgis = 20
    sa = 21
    sais = 22
    sh = 23
End Enum

Public MustInherit Class lineObject

    Public Shared ordDelky() As Single = {0.5, 1, 1.5, 2, 3, 4, 6}

    Dim _delka As Single = 1
    Public Property delka() As Single
        Get
            Return _delka
        End Get
        Set(ByVal value As Single)
            _delka = value
        End Set
    End Property

    Sub SetDelka(ByVal d As Single)
        delka = d
    End Sub

End Class

Public Class Nota
    Inherits lineObject

    Sub New(ByVal del As String, ByVal vys As String)
        'určit délku
        Dim length As Single = Val(del)
        If length < 0.5 Or length > 10 Then Throw New Exception("Neplatná délka noty!")
        If length * 2 <> Math.Round(length * 2) Then Throw New Exception("Neplatná délka noty!")
        delka = length

        'určit výšku
        If Char.IsLower(vys(0)) Then vys = "s" & vys
        vys = vys.ToLower()
        vyska = System.Enum.Parse(GetType(VyskaTonu), vys)
    End Sub

    Sub New(ByVal length As Single, ByVal height As Integer)
        If length < 0.5 Or length > 10 Then Throw New Exception("Neplatná délka noty!")
        If length * 2 <> Math.Round(length * 2) Then Throw New Exception("Neplatná délka noty!")
        delka = length
        vyska = height
    End Sub

    Dim _vyska As VyskaTonu = VyskaTonu.c
    Public Property vyska() As VyskaTonu
        Get
            Return _vyska
        End Get
        Set(ByVal value As VyskaTonu)
            _vyska = value
        End Set
    End Property

    Public Sub SetVyska(ByVal vys As VyskaTonu)
        vyska = vys
    End Sub

    Public Shared Function Draw(ByRef g As Graphics, ByVal x As Integer, ByVal y As Integer, ByVal vyska As VyskaTonu, ByVal delka As Single, ByRef pocet As Integer) As Integer
        'rozdělí notu na běžné délky a vykreslí její části
        Dim lx As Integer = 0
        For i As Integer = ordDelky.Length - 1 To 0 Step -1
            While ordDelky(i) <= delka
                lx += DrawNota(g, x + lx, y, vyska, delka)
                pocet += 1
                delka -= ordDelky(i)
            End While
        Next
        Return lx
    End Function

    ''' <summary>
    ''' Vykreslení noty
    ''' </summary>
    ''' <param name="x"></param>
    ''' <param name="y"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Shared Function DrawNota(ByRef g As Graphics, ByVal x As Integer, ByVal y As Integer, ByVal vyska As VyskaTonu, ByVal delka As Single) As Integer
        Dim krizek As Boolean = False
        Dim nahoru As Boolean = (vyska <= VyskaTonu.h)
        Dim tecka As Boolean = False
        Dim ly As Integer = y

        'vykreslit obrázek
        Select Case vyska
            Case VyskaTonu.c : y += 18
            Case VyskaTonu.cis : y += 18 : krizek = True
            Case VyskaTonu.d : y += 14
            Case VyskaTonu.dis : y += 14 : krizek = True
            Case VyskaTonu.e : y += 9
            Case VyskaTonu.f : y += 4
            Case VyskaTonu.fis : y += 4 : krizek = True
            Case VyskaTonu.g : y -= 1
            Case VyskaTonu.gis : y -= 1 : krizek = True
            Case VyskaTonu.a : y -= 6
            Case VyskaTonu.ais : y -= 6 : krizek = True
            Case VyskaTonu.h : y -= 11

            Case VyskaTonu.sc : y += 10
            Case VyskaTonu.scis : y += 10 : krizek = True
            Case VyskaTonu.sd : y += 5
            Case VyskaTonu.sdis : y += 5 : krizek = True
            Case VyskaTonu.se : y += 0
            Case VyskaTonu.sf : y -= 5
            Case VyskaTonu.sfis : y -= 5 : krizek = True
            Case VyskaTonu.sg : y -= 10
            Case VyskaTonu.sgis : y -= 10 : krizek = True
            Case VyskaTonu.sa : y -= 14
            Case VyskaTonu.sais : y -= 14 : krizek = True
            Case VyskaTonu.sh : y -= 20
        End Select

        'podle délky určit tečku
        If delka = 1.5 Or delka = 3 Or delka = 6 Then tecka = True

        'vybrat obrázek
        Dim img As Image
        If nahoru Then
            If krizek Then
                If delka = 0.5 Then
                    img = My.Resources.nota_krizek_nahoru_0
                ElseIf delka < 2 Then
                    img = My.Resources.nota_krizek_nahoru_1
                ElseIf delka < 4 Then
                    img = My.Resources.nota_krizek_nahoru_2
                Else
                    img = My.Resources.nota_krizek_4
                End If
            Else
                If delka = 0.5 Then
                    img = My.Resources.nota_nahoru_0
                ElseIf delka < 2 Then
                    img = My.Resources.nota_nahoru_1
                ElseIf delka < 4 Then
                    img = My.Resources.nota_nahoru_2
                Else
                    img = My.Resources.nota_4
                End If
            End If
        Else
            If krizek Then
                If delka = 0.5 Then
                    img = My.Resources.nota_krizek_dolu_0
                ElseIf delka < 2 Then
                    img = My.Resources.nota_krizek_dolu_1
                ElseIf delka < 4 Then
                    img = My.Resources.nota_krizek_dolu_2
                Else
                    img = My.Resources.nota_krizek_4
                End If
            Else
                If delka = 0.5 Then
                    img = My.Resources.nota_dolu_0
                ElseIf delka < 2 Then
                    img = My.Resources.nota_dolu_1
                ElseIf delka < 4 Then
                    img = My.Resources.nota_dolu_2
                Else
                    img = My.Resources.nota_4
                End If
            End If
        End If

        'modifikace kvůli různým velikostem obrázků
        If krizek Then
            x -= 13
            If Not nahoru Then y -= 9 Else y -= 1
        End If
        If delka >= 4 Then
            If krizek And nahoru Then y -= 8
            If Not nahoru Then y += 0 Else y += 27
        End If

        'vykreslit notu
        g.DrawImage(img, x, y, CInt(img.Width * 0.85), CInt(img.Height * 0.85))

        'modifikace kvůli různým velikostem obrázků
        If krizek Then
            x += 13
            If Not nahoru Then y += 9 Else y += 1
        End If
        If delka >= 4 Then
            If krizek Then y += 8
            If Not nahoru Then y -= 0 Else y -= 27
        End If

        'vykreslit tečku u noty
        If tecka Then
            If Not nahoru Then
                g.FillEllipse(Brushes.Black, x + 18, y - 3, 5, 5)
            Else
                g.FillEllipse(Brushes.Black, x + 18, y + 27, 5, 5)
            End If
        End If

        'pomocné linky
        If vyska < VyskaTonu.d Then g.DrawLine(Pens.Black, x - 3, y + 32, x + 15, y + 32)
        If vyska = VyskaTonu.sa Or vyska = VyskaTonu.sais Then g.DrawLine(Pens.Black, x - 3, y + 5, x + 15, y + 5)
        If vyska = VyskaTonu.sh Then g.DrawLine(Pens.Black, x - 3, y + 11, x + 15, y + 11)

        Return 10 + 40 * delka
    End Function

End Class

Public Class Pomlka
    Inherits lineObject

    Sub New(ByVal length As Single)
        'určit délku
        If length < 0.5 Or length > 10 Then Throw New Exception("Neplatná délka noty!")
        If length * 2 <> Math.Round(length * 2) Then Throw New Exception("Neplatná délka noty!")
        delka = length
    End Sub

    Sub New(ByVal del As String)
        'určit délku
        Dim length As Single = Val(del)
        If length < 0.5 Or length > 10 Then Throw New Exception("Neplatná délka noty!")
        If length * 2 <> Math.Round(length * 2) Then Throw New Exception("Neplatná délka noty!")
        delka = length
    End Sub

    ''' <summary>
    ''' Vykreslení pomlky
    ''' </summary>
    ''' <param name="x"></param>
    ''' <param name="y"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Shared Function Draw(ByRef g As Graphics, ByVal x As Integer, ByVal y As Integer, ByVal delka As Single) As Integer
        'rozdělí notu na běžné délky a vykreslí její části
        Dim lx As Integer = 0
        For i As Integer = ordDelky.Length - 1 To 0 Step -1
            While ordDelky(i) <= delka
                lx += DrawPomlka(g, x + lx, y, delka)
                delka -= ordDelky(i)
            End While
        Next
        Return lx
    End Function

    ''' <summary>
    ''' Vykreslení pomlky
    ''' </summary>
    ''' <param name="x"></param>
    ''' <param name="y"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Shared Function DrawPomlka(ByRef g As Graphics, ByVal x As Integer, ByVal y As Integer, ByVal delka As Single) As Integer
        Dim tecka As Boolean = False

        'podle délky určit tečku
        If delka = 1.5 Or delka = 3 Or delka = 6 Then tecka = True

        'vybrat obrázek
        Dim img As Image

        If delka = 0.5 Then
            img = My.Resources.pomlka_0
            y += 10
        ElseIf delka < 2 Then
            img = My.Resources.pomlka_1
            y += 7
        ElseIf delka < 4 Then
            img = My.Resources.pomlka_2
            y += 15
        Else
            img = My.Resources.pomlka_4
            y += 10
        End If

        'vykreslit pomlku
        g.DrawImage(img, x, y, CInt(img.Width * 0.85), CInt(img.Height * 0.85))

        Return 10 + 40 * delka
    End Function

End Class
